import java.util.Arrays;
import java.util.List;

import com.jgoodies.binding.beans.Model;

public class Feed extends Model {
    private long id = 0;
    private String name;
    private String siteUrl;
    private String feedUrl;
    private FeedType feedType;
    private boolean customCheckIntervalEnabled = false;
    private Integer checkInterval;

    public Feed() {
    }

    public Feed(String name, String siteUrl, String feedUrl, FeedType feedType) {
        this.name = name;
        this.siteUrl = siteUrl;
        this.feedUrl = feedUrl;
        this.feedType = feedType;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String newName) {
        String oldName = this.name;
        this.name = newName;
        firePropertyChange("name", oldName, newName);
    }

    public String getSiteUrl() {
        return siteUrl;
    }

    public void setSiteUrl(String newSiteUrl) {
        String oldSiteUrl = this.siteUrl;
        this.siteUrl = newSiteUrl;
        firePropertyChange("siteUrl", oldSiteUrl, newSiteUrl);
    }

    public String getFeedUrl() {
        return feedUrl;
    }

    public void setFeedUrl(String newFeedUrl) {
        String oldFeedUrl = this.feedUrl;
        this.feedUrl = newFeedUrl;
        firePropertyChange("feedUrl", oldFeedUrl, newFeedUrl);
    }

    public FeedType getFeedType() {
        return feedType;
    }

    public void setFeedType(FeedType newFeedType) {
        FeedType oldFeedType = this.feedType;
        this.feedType = newFeedType;
        firePropertyChange("feedType", oldFeedType, newFeedType);
    }

    public boolean isCustomCheckIntervalEnabled() {
        return customCheckIntervalEnabled;
    }

    public void setCustomCheckIntervalEnabled(boolean newCustomCheckIntervalEnabled) {
        boolean oldCustomCheckIntervalEnabled = this.customCheckIntervalEnabled;
        this.customCheckIntervalEnabled = newCustomCheckIntervalEnabled;
        firePropertyChange("customCheckIntervalEnabled", oldCustomCheckIntervalEnabled, newCustomCheckIntervalEnabled);
    }

    public Integer getCheckInterval() {
        return checkInterval;
    }

    public void setCheckInterval(Integer newCheckInterval) {
        Integer oldCheckInterval = this.checkInterval;
        this.checkInterval = newCheckInterval;
        firePropertyChange("checkInterval", oldCheckInterval, newCheckInterval);
    }

    public String toString() {
        return this.name;
    }


}


class FeedType {
    private String type;

    private FeedType(String type) {
        this.type = type;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof FeedType)) return false;

        final FeedType feedType = (FeedType) o;

        if (type != null ? !type.equals(feedType.type) : feedType.type != null) return false;

        return true;
    }

    public int hashCode() {
        return (type != null ? type.hashCode() : 0);
    }

    public String toString() {
        return this.type;
    }

    public static FeedType RSS_09 = new FeedType("RSS_09");
    public static FeedType RSS_093 = new FeedType("RSS_093");
    public static FeedType RSS_20 = new FeedType("RSS_20");
    public static FeedType ATOM_03 = new FeedType("ATOM_03");

    public static final List TYPES = Arrays.asList(new FeedType[]{
        RSS_09, RSS_093, RSS_20, ATOM_03});

}
