import com.jgoodies.binding.PresentationModel;
import com.jgoodies.validation.ValidationCapable;
import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.util.ValidationUtils;

public class FeedPresentationModelValidator implements ValidationCapable {
    PresentationModel prModel;

    public FeedPresentationModelValidator(PresentationModel presentationModel) {
        this.prModel = presentationModel;
    }

    public ValidationResult validate() {
        ValidationResult validationResult = new ValidationResult();

        String name = (String) this.prModel.getModel("name").getValue();
        String feedUrl = (String) this.prModel.getModel("feedUrl").getValue();
        String siteUrl = (String) this.prModel.getModel("siteUrl").getValue();

        if (ValidationUtils.isEmpty(name)) {
            validationResult.addError("The name field can not be blank.");
        } else if (!ValidationUtils.hasBoundedLength(name, 5, 14)) {
            validationResult.addError("The name field must be between 5 and 14 characters.");
        }

        if (!"ClientJava.com".equals(name)) {
            validationResult.addWarning("This form prefers the feed ClientJava.com");
        }


        if (ValidationUtils.isEmpty(feedUrl)) {
            validationResult.addError("The feed field can not be blank.");
        }

        if (ValidationUtils.isEmpty(siteUrl)) {
            validationResult.addError("The site field can not be blank.");
        }

        return validationResult;
    }
}
