import com.jgoodies.validation.Severity;
import com.jgoodies.validation.ValidationCapable;
import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.util.ValidationUtils;

import java.util.List;

public class NonEmptyModelValidator implements ValidationCapable {
    protected FieldListModel fieldModel;

    public NonEmptyModelValidator(FieldListModel fieldModel) {
        this.fieldModel = fieldModel;
    }

    public ValidationResult validate() {
        ValidationResult validationResult = new ValidationResult();

        List fields = this.fieldModel.getFields();
        for (int i = 0; i < fields.size(); i++) {
            String fieldName = (String) fields.get(i);
            String value = (String) this.fieldModel.getModel(fieldName).getValue();
            if (ValidationUtils.isEmpty(value)) {
                FieldValidationMessage message = new FieldValidationMessage("The field " + fieldName + " can not be empty.", Severity.ERROR, fieldName);
                validationResult.add(message);
            }
        }
        return validationResult;
    }
}
